package compbio.listeners;

import java.io.IOException;
import java.util.List;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import compbio.cassandra.DataBase;
import compbio.statistic.CassandraRequester;
import compbio.statistic.StatisticsProt;

/**
 * Servlet implementation class ProtServlet
 */
@WebServlet("/ServletSequenceProtein")
public class ServletSequenceProtein extends HttpServlet {
	private static final long serialVersionUID = 1L;

	/**
	 * @see HttpServlet#doGet(HttpServletRequest request, HttpServletResponse
	 *      response)
	 */
	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		final long startTime = System.currentTimeMillis();
		String flag = request.getParameter("protein");
		String prot = request.getParameter("prot");
		String search = request.getParameter("Search");
		int counter = Integer.parseInt(request.getParameter("counterJob"));
		CassandraRequester cr = new CassandraRequester();
		if (search.equals("Search counter")) {
			List<DataBase> r = cr.readProteinByCounter(counter);
	 		request.setAttribute("results", r);
	//		System.out.println ("Search counter: " + r.size() + " proteins found");
		} else {
			List<DataBase> r = cr.readProteins(prot, flag);
			request.setAttribute("results", r);
		//	System.out.println ("Search sequence: " + r.size() + " proteins found");
		}
		final long endTime = System.currentTimeMillis();
		request.setAttribute("timeExecution", (endTime - startTime));
		request.setAttribute("prot", prot);
		request.setAttribute("flag", flag);
		request.setAttribute("search", search);
		request.setAttribute("counter", counter);
		RequestDispatcher rd = request.getRequestDispatcher("/ReportSequenceProtein.jsp");
		rd.forward(request, response);
	}

	/**
	 * @see HttpServlet#doPost(HttpServletRequest request, HttpServletResponse
	 *      response)
	 */
	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		doGet(request, response);
	}

}
